#include "SurfaceList.h"

void SurfaceList::addSurface(std::shared_ptr<Surface> surface){
    surfaces.push_back(surface);
}

Intersection SurfaceList::intersect(Ray ray, float t0, float t1){
    Intersection result;

    // Go through all surfaces and check for an intersection:
    for(std::shared_ptr<Surface>& surface : surfaces){
        Intersection tmpResult = surface->intersect(ray, t0, t1);

        // If an intersection was found, only search for nearer intersections
        // by restricting the last parameter:
        if(tmpResult.hasIntersection){
            result = tmpResult;
            t1 = result.t;
        }
    }

    return result;
}
